import * as graphql from 'graphql';
import { GraphQLSchema, DocumentNode, Source, GraphQLError, GraphQLNamedType } from 'graphql';
import typescript, { TaggedTemplateExpression, TypeChecker, TaggedTemplateExpressionHook } from 'typescript';
import { TaggedTemplateExpression as TaggedTemplateExpression$1 } from 'typescript/lib/tsserverlibrary';

declare const getArgs: (ts: typeof typescript, schema: GraphQLSchema, node: TaggedTemplateExpression, checker: TypeChecker, documentNode: DocumentNode) => typescript.Expression[] | undefined;

declare const factory: (schema: GraphQLSchema) => TaggedTemplateExpressionHook;

declare type GraphqlTag = "gql" | "useQuery" | "useMutation";
declare const isGraphqlTag: (tagName: string) => tagName is GraphqlTag;

declare const minify: (value: Source) => Source;

declare const parse: (value: Source) => graphql.DocumentNode | GraphQLError;

declare const query: (ts: typeof typescript, schema: GraphQLSchema, node: TaggedTemplateExpression$1) => {
    query: string;
    offset: number;
};

declare const getSchema: () => Promise<GraphQLSchema>;
declare const getSchemaSync: () => GraphQLSchema;
declare const watchSchema: (callback: (schema: GraphQLSchema) => void) => GraphQLSchema;

declare const source: (value: string) => Source;

declare const getTypescriptType: (ts: typeof typescript, checker: TypeChecker, namedType: GraphQLNamedType) => typescript.Type;

declare const validate: (k1: GraphQLSchema, k2: DocumentNode) => readonly graphql.GraphQLError[];

export { factory, getArgs, getSchema, getSchemaSync, getTypescriptType, isGraphqlTag, minify, parse, query, source, validate, watchSchema };
